Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Member Functions
Lucene::ReadOnlyDirectoryReader Class Reference

`#include <ReadOnlyDirectoryReader.h>`

Inheritance diagram for Lucene::ReadOnlyDirectoryReader:

## Public Member Functions

| ReadOnlyDirectoryReader (const DirectoryPtr &directory, const SegmentInfosPtr &sis, const IndexDeletionPolicyPtr &deletionPolicy, int32_t termInfosIndexDivisor)
| ReadOnlyDirectoryReader (const DirectoryPtr &directory, const SegmentInfosPtr &infos, Collection< SegmentReaderPtr > oldReaders, Collection< int32_t > oldStarts, MapStringByteArray oldNormsCache, bool doClone, int32_t termInfosIndexDivisor)
| ReadOnlyDirectoryReader (const IndexWriterPtr &writer, const SegmentInfosPtr &infos, int32_t termInfosIndexDivisor)
virtual | ~ReadOnlyDirectoryReader ()
virtual String | getClassName ()
boost::shared_ptr< ReadOnlyDirectoryReader > | shared_from_this ()
virtual void | acquireWriteLock ()
| Tries to acquire the WriteLock on this directory. this method is only valid if this IndexReader is directory owner. More...
Public Member Functions inherited from Lucene::DirectoryReader
| DirectoryReader (const DirectoryPtr &directory, const SegmentInfosPtr &sis, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly, int32_t termInfosIndexDivisor)
| Construct reading the named set of readers. More...
| DirectoryReader (const IndexWriterPtr &writer, const SegmentInfosPtr &infos, int32_t termInfosIndexDivisor)
| Used by near real-time search. More...
| DirectoryReader (const DirectoryPtr &directory, const SegmentInfosPtr &infos, Collection< SegmentReaderPtr > oldReaders, Collection< int32_t > oldStarts, MapStringByteArray oldNormsCache, bool readOnly, bool doClone, int32_t termInfosIndexDivisor)
| This constructor is only used for reopen(). More...
virtual | ~DirectoryReader ()
boost::shared_ptr< DirectoryReader > | shared_from_this ()
void | _initialize (Collection< SegmentReaderPtr > subReaders)
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Efficiently clones the IndexReader (sharing most internal state). More...
virtual LuceneObjectPtr | clone (bool openReadOnly, const LuceneObjectPtr &other=LuceneObjectPtr())
| Clones the IndexReader and optionally changes readOnly. A readOnly reader cannot open a writable reader. More...
virtual IndexReaderPtr | reopen ()
| Refreshes an IndexReader if the index has changed since this instance was (re)opened. More...
virtual IndexReaderPtr | reopen (bool openReadOnly)
| Just like reopen(), except you can change the readOnly of the original reader. If the index is unchanged but readOnly is different then a new reader will be returned. More...
virtual IndexReaderPtr | reopen (const IndexCommitPtr &commit)
| Reopen this reader on a specific commit point. This always returns a readOnly reader. If the specified commit point matches what this reader is already on, and this reader is already readOnly, then this same instance is returned; if it is not already readOnly, a readOnly clone is returned. More...
virtual int64_t | getVersion ()
| Version number when this IndexReader was opened. More...
virtual Collection< TermFreqVectorPtr > | getTermFreqVectors (int32_t docNumber)
| Return an array of term frequency vectors for the specified document. More...
virtual TermFreqVectorPtr | getTermFreqVector (int32_t docNumber, const String &field)
| Return a term frequency vector for the specified document and field. More...
virtual void | getTermFreqVector (int32_t docNumber, const String &field, const TermVectorMapperPtr &mapper)
| Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the TermFreqVector. More...
virtual void | getTermFreqVector (int32_t docNumber, const TermVectorMapperPtr &mapper)
| Map all the term vectors for all fields in a Document. More...
virtual bool | isOptimized ()
| Checks is the index is optimized (if it has a single segment and no deletions). Not implemented in the IndexReader base class. More...
virtual int32_t | numDocs ()
| Returns the number of documents in this index. More...
virtual int32_t | maxDoc ()
| Returns one greater than the largest possible document number. More...
virtual DocumentPtr | document (int32_t n, const FieldSelectorPtr &fieldSelector)
| Get the Document at the n'th position. The FieldSelector may be used to determine what Fields to load and how they should be loaded. More...
virtual bool | isDeleted (int32_t n)
| Returns true if document n has been deleted. More...
virtual bool | hasDeletions ()
| Returns true if any documents have been deleted. More...
virtual bool | hasNorms (const String &field)
| Returns true if there are norms stored for this field. More...
virtual ByteArray | norms (const String &field)
| Returns the byte-encoded normalization factor for the named field of every document. More...
virtual void | norms (const String &field, ByteArray norms, int32_t offset)
| Reads the byte-encoded normalization factor for the named field of every document. More...
virtual TermEnumPtr | terms ()
| Returns an enumeration of all the terms in the index. More...
virtual TermEnumPtr | terms (const TermPtr &t)
| Returns an enumeration of all terms starting at a given term. More...
virtual int32_t | docFreq (const TermPtr &t)
| Returns the number of documents containing the term t. More...
virtual TermDocsPtr | termDocs ()
| Returns an unpositioned TermDocs enumerator. More...
virtual TermPositionsPtr | termPositions ()
| Returns an unpositioned TermPositions enumerator. More...
void | startCommit ()
void | rollbackCommit ()
virtual MapStringString | getCommitUserData ()
| Retrieve the String userData optionally passed to IndexWriter::commit. More...
virtual bool | isCurrent ()
| Check whether any new changes have occurred to the index since this reader was opened. More...
virtual HashSet< String > | getFieldNames (FieldOption fieldOption)
| Get a list of unique field names that exist in this index and have the specified field option information. More...
virtual Collection< IndexReaderPtr > | getSequentialSubReaders ()
| Returns the sequential sub readers that this reader is logically composed of. More...
virtual DirectoryPtr | directory ()
| Returns the directory this index resides in. More...
virtual int32_t | getTermInfosIndexDivisor ()
| For IndexReader implementations that use TermInfosReader to read terms, this returns the current indexDivisor as specified when the reader was opened. More...
virtual IndexCommitPtr | getIndexCommit ()
| Return the IndexCommit that this reader has opened. More...
Public Member Functions inherited from Lucene::IndexReader
| IndexReader ()
virtual | ~IndexReader ()
boost::shared_ptr< IndexReader > | shared_from_this ()
int32_t | getRefCount ()
| Returns the current refCount for this reader. More...
void | incRef ()

Increments the refCount of this IndexReader instance. RefCounts are used to determine when a reader can be closed safely, i.e. as soon as there are no more references. Be sure to always call a corresponding decRef, in a finally clause; otherwise the reader may never be closed. Note that close simply calls decRef(), which means that the IndexReader will not really be closed until decRef has been called for all outstanding references. More...

void | decRef ()
| Decreases the refCount of this IndexReader instance. If the refCount drops to 0, then pending changes (if any) are committed to the index and this reader is closed. More...
int32_t | numDeletedDocs ()
| Returns the number of deleted documents. More...
virtual DocumentPtr | document (int32_t n)
| Returns the stored fields of the n'th Document in this index. More...
virtual bool | hasChanges ()
| Used for testing. More...
virtual void | setNorm (int32_t doc, const String &field, uint8_t value)
| Resets the normalization factor for the named field of the named document. The norm represents the product of the field's boost and its length normalization. Thus, to preserve the length normalization values when resetting this, one should base the new value upon the old. More...
virtual void | setNorm (int32_t doc, const String &field, double value)
| Resets the normalization factor for the named field of the named document. More...
virtual TermDocsPtr | termDocs (const TermPtr &term)
| Returns an enumeration of all the documents which contain term. For each document, the document number, the frequency of the term in that document is also provided, for use in search scoring. If term is null, then all non-deleted docs are returned with freq=1. The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration. More...
virtual TermPositionsPtr | termPositions (const TermPtr &term)

Returns an enumeration of all the documents which contain term. For each document, in addition to the document number and frequency of the term in that document, a list of all of the ordinal positions of the term in the document is available. Thus, this method positions of the term in the document is available. This positional information facilitates phrase and proximity searching. The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration. More...

virtual void | deleteDocument (int32_t docNum)
| Deletes the document numbered docNum. Once a document is deleted it will not appear in TermDocs or TermPostitions enumerations. Attempts to read its field with the document method will result in an error. The presence of this document may still be reflected in the docFreq statistic, though this will be corrected eventually as the index is further modified. More...
virtual int32_t | deleteDocuments (const TermPtr &term)
| Deletes all documents that have a given term indexed. This is useful if one uses a document field to hold a unique ID string for the document. Then to delete such a document, one merely constructs a term with the appropriate field and the unique ID string as its text and passes it to this method. See deleteDocument(int) for information about when this deletion will become effective. More...
virtual void | undeleteAll ()
| Undeletes all documents currently marked as deleted in this index. More...
void | flush ()
void | flush (MapStringString commitUserData)
void | commit (MapStringString commitUserData)
| Commit changes resulting from delete, undeleteAll, or setNorm operations. If an exception is hit, then either no changes or all changes will have been committed to the index (transactional semantics). More...
void | close ()
| Closes files associated with this index. Also saves any new deletions to disk. No other methods should be called after this has been called. More...
virtual LuceneObjectPtr | getFieldCacheKey ()
virtual LuceneObjectPtr | getDeletesCacheKey ()
| This returns null if the reader has no deletions. More...
virtual int64_t | getUniqueTermCount ()
| Returns the number of unique terms (across all fields) in this reader. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::DirectoryReader
static String | _getClassName ()
static IndexReaderPtr | open (const DirectoryPtr &directory, const IndexDeletionPolicyPtr &deletionPolicy, const IndexCommitPtr &commit, bool readOnly, int32_t termInfosIndexDivisor)
static int32_t | readerIndex (int32_t n, Collection< int32_t > starts, int32_t numSubReaders)
| Find reader for doc n. More...
static HashSet< String > | getFieldNames (FieldOption fieldOption, Collection< IndexReaderPtr > subReaders)
static Collection< IndexCommitPtr > | listCommits (const DirectoryPtr &dir)
| Returns all commit points that exist in the Directory. More...
Static Public Member Functions inherited from Lucene::IndexReader
static String | _getClassName ()
static IndexReaderPtr | open (const DirectoryPtr &directory)
| Returns a IndexReader reading the index in the given Directory, with readOnly = true. More...
static IndexReaderPtr | open (const DirectoryPtr &directory, bool readOnly)
| Returns an IndexReader reading the index in the given Directory. You should pass readOnly = true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (const IndexCommitPtr &commit, bool readOnly)
| Returns an IndexReader reading the index in the given IndexCommit. You should pass readOnly = true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (const DirectoryPtr &directory, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly)
| Returns an IndexReader reading the index in the given Directory, with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (const DirectoryPtr &directory, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly, int32_t termInfosIndexDivisor)
| Returns an IndexReader reading the index in the given Directory, with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (const IndexCommitPtr &commit, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly)
| Returns an IndexReader reading the index in the given Directory, using a specific commit and with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (const IndexCommitPtr &commit, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly, int32_t termInfosIndexDivisor)
| Returns an IndexReader reading the index in the given Directory, using a specific commit and with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static int64_t | lastModified (const DirectoryPtr &directory2)
| Returns the time the index in the named directory was last modified. Do not use this to check whether the reader is still up-to-date, use isCurrent() instead. More...
static int64_t | getCurrentVersion (const DirectoryPtr &directory)
| Reads version number from segments files. The version number is initialized with a timestamp and then increased by one for each change of the index. More...
static MapStringString | getCommitUserData (const DirectoryPtr &directory)
| Reads commitUserData, previously passed to IndexWriter#commit(MapStringString), from current index segments file. This will return null if IndexWriter#commit(MapStringString) has never been called for this index. More...
static bool | indexExists (const DirectoryPtr &directory)
| Returns true if an index exists at the specified directory. If the directory does not exist or if there is no index in it. More...
static void | main (Collection< String > args)
| Prints the filename and size of each file within a given compound file. Add the -extract flag to extract files to the current working directory. In order to make the extracted version of the index work, you have to copy the segments file from the compound index into the directory where the extracted files are stored. More...
static Collection< IndexCommitPtr > | listCommits (const DirectoryPtr &dir)

Returns all commit points that exist in the Directory. Normally, because the default is KeepOnlyLastCommitDeletionPolicy, there would be only one commit point. But if you're using a custom IndexDeletionPolicy then there could be many commits. Once you have a given commit, you can open a reader on it by calling IndexReader#open(IndexCommit,bool). There must be at least one commit in the Directory, else this method throws an exception. Note that if a commit is in progress while this method is running, that commit may or may not be returned array. More...

## Additional Inherited Members

Public Types inherited from Lucene::IndexReader
enum | FieldOption { FIELD_OPTION_ALL, FIELD_OPTION_INDEXED, FIELD_OPTION_STORES_PAYLOADS, FIELD_OPTION_OMIT_TERM_FREQ_AND_POSITIONS, FIELD_OPTION_UNINDEXED, FIELD_OPTION_INDEXED_WITH_TERMVECTOR, FIELD_OPTION_INDEXED_NO_TERMVECTOR, FIELD_OPTION_TERMVECTOR, FIELD_OPTION_TERMVECTOR_WITH_POSITION, FIELD_OPTION_TERMVECTOR_WITH_OFFSET, FIELD_OPTION_TERMVECTOR_WITH_POSITION_OFFSET }
| Constants describing field properties, for example used for IndexReader#getFieldNames(FieldOption). More...
Static Public Attributes inherited from Lucene::IndexReader
static const int32_t | DEFAULT_TERMS_INDEX_DIVISOR
Protected Member Functions inherited from Lucene::DirectoryReader
IndexReaderPtr | doReopenFromWriter (bool openReadOnly, const IndexCommitPtr &commit)
IndexReaderPtr | doReopen (bool openReadOnly, const IndexCommitPtr &commit)
IndexReaderPtr | doReopenNoWriter (bool openReadOnly, const IndexCommitPtr &commit)
DirectoryReaderPtr | doReopen (const SegmentInfosPtr &infos, bool doClone, bool openReadOnly)
virtual void | doDelete (int32_t docNum)
| Implements deletion of the document numbered docNum. More...
virtual void | doUndeleteAll ()
| Implements actual undeleteAll() in subclass. More...
int32_t | readerIndex (int32_t n)
virtual void | doSetNorm (int32_t doc, const String &field, uint8_t value)
| Implements setNorm in subclass. More...
virtual void | doCommit (MapStringString commitUserData)
| Commit changes resulting from delete, undeleteAll, or setNorm operations. More...
virtual void | doClose ()
| Implements close. More...
Protected Member Functions inherited from Lucene::IndexReader
void | ensureOpen ()
void | commit ()
| Commit changes resulting from delete, undeleteAll, or setNorm operations. If an exception is hit, then either no changes or all changes will have been committed to the index (transactional semantics). More...
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()
Static Protected Member Functions inherited from Lucene::IndexReader
static IndexReaderPtr | open (const DirectoryPtr &directory, const IndexDeletionPolicyPtr &deletionPolicy, const IndexCommitPtr &commit, bool readOnly, int32_t termInfosIndexDivisor)
Protected Attributes inherited from Lucene::DirectoryReader
DirectoryPtr | _directory
bool | readOnly
IndexWriterWeakPtr | _writer
IndexDeletionPolicyPtr | deletionPolicy
HashSet< String > | synced
LockPtr | writeLock
SegmentInfosPtr | segmentInfos
SegmentInfosPtr | segmentInfosStart
bool | stale
int32_t | termInfosIndexDivisor
bool | rollbackHasChanges
Collection< SegmentReaderPtr > | subReaders
Collection< int32_t > | starts
MapStringByteArray | normsCache
int32_t | _maxDoc
int32_t | _numDocs
bool | _hasDeletions
int64_t | maxIndexVersion
Protected Attributes inherited from Lucene::IndexReader
bool | closed
bool | _hasChanges
int32_t | refCount
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Constructor & Destructor Documentation

Lucene::ReadOnlyDirectoryReader::ReadOnlyDirectoryReader | ( | const DirectoryPtr & | directory,
|  | const SegmentInfosPtr & | sis,
|  | const IndexDeletionPolicyPtr & | deletionPolicy,
|  | int32_t | termInfosIndexDivisor
| ) |  |

Lucene::ReadOnlyDirectoryReader::ReadOnlyDirectoryReader | ( | const DirectoryPtr & | directory,
|  | const SegmentInfosPtr & | infos,
|  | Collection< SegmentReaderPtr > | oldReaders,
|  | Collection< int32_t > | oldStarts,
|  | MapStringByteArray | oldNormsCache,
|  | bool | doClone,
|  | int32_t | termInfosIndexDivisor
| ) |  |

Lucene::ReadOnlyDirectoryReader::ReadOnlyDirectoryReader | ( | const IndexWriterPtr & | writer,
|  | const SegmentInfosPtr & | infos,
|  | int32_t | termInfosIndexDivisor
| ) |  |

virtual Lucene::ReadOnlyDirectoryReader::~ReadOnlyDirectoryReader | ( |  | ) |

virtual

## Member Function Documentation

static String Lucene::ReadOnlyDirectoryReader::_getClassName | ( |  | ) |

inline static

virtual void Lucene::ReadOnlyDirectoryReader::acquireWriteLock | ( |  | ) |

virtual

Tries to acquire the WriteLock on this directory. this method is only valid if this IndexReader is directory owner.

Reimplemented from Lucene::DirectoryReader.

virtual String Lucene::ReadOnlyDirectoryReader::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::DirectoryReader.

boost::shared_ptr< ReadOnlyDirectoryReader > Lucene::ReadOnlyDirectoryReader::shared_from_this | ( |  | ) |

inline

The documentation for this class was generated from the following file:

- ReadOnlyDirectoryReader.h

clucene.sourceforge.net